.486
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include ReadRegKey.inc
include E:\Program Files\RadASM\Masm32\macros\macros.asm
;include E:\Program Files\RadASM\Masm32\m32lib\szmulcat.asm

.data
    lpszComputerNameSubKey		DB  "SYSTEM\CurrentControlSet\Control\ComputerName\ComputerName",0
    lpszComputerNameValueName   DB  "ComputerName",0
    lpszScreenSaverSubKey		DB	".DEFAULT\Control Panel\Desktop",0
    lpszScreenSaverValueName	DB	"ScreenSaveActive",0
	szMBCapt					DB	"Registry Error",0
	szNoFindKey					DB	"Key not present.",0
	szNoFindVal					DB	"Value not present.",0
    MsgActive					DB	"Active",0
    MsgInactive					DB	"Inactive",0
    szColon						BYTE	":", 0

.data?
    lpbData		DD 256 Dup (?)
    lpbSCRData	DD 256 Dup (?)
    TimeStr		DD 64 Dup (0)
    lpcbData    DD  ?
    lpdwType    DD  ?
	VBufLen		dd	?
	SCRVBufLen	DD	?
	Buffer		db 1024 dup(?)
	wdat		WSADATA <?>
	LocalTime	SYSTEMTIME <?>
    getip		PROTO
    lpbIP		DD ?

.code

start:
	invoke	GetModuleHandle,NULL
	mov	hInstance,eax
	invoke	GetLocalTime, ADDR LocalTime
	invoke	InitCommonControls
	invoke	FindComputerName
	invoke	GetScreenSaverState
	invoke	getip
	invoke	DialogBoxParam,hInstance,IDD_MAIN,NULL,addr DlgProc,NULL
	invoke	ExitProcess,0

;########################################################################


DlgProc	proc	hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL str1:DWORD
	LOCAL hour:DWORD
	LOCAL minute:DWORD
	LOCAL second:DWORD
	LOCAL	lpszHour[24]:BYTE
	LOCAL	lpszMinute[24]:BYTE
	LOCAL	lpszSecond[24]:BYTE
	LOCAL	TimeStr2[72]:BYTE
	invoke memfill,addr lpszHour,24,0
	invoke memfill,addr lpszMinute,24,0
	invoke memfill,addr lpszSecond,24,0
	invoke memfill,addr TimeStr2,72,0
	mov	eax,uMsg	
	.if	eax==WM_INITDIALOG

		;initialization here
		invoke SetTimer,hWin,400,1000,0
	    INVOKE	SendDlgItemMessage,hWin,103,WM_SETTEXT, 0, OFFSET lpbData+NULL
	    INVOKE	SendDlgItemMessage,hWin,105,WM_SETTEXT, 0, DWORD PTR [lpbIP]+NULL
	    .if [lpbSCRData]=="1"
	    	lea eax, MsgActive
	    .else
	    	lea eax, MsgInactive
	    .endif
	    INVOKE SendDlgItemMessage,hWin,107,WM_SETTEXT, 0, eax
	    
	.elseif	eax==WM_COMMAND
		mov edx,wParam
		movzx eax,dx
		shr edx,16
		.if edx==BN_CLICKED
			.if eax==IDOK
				invoke	SendMessage,hWin,WM_CLOSE,NULL,NULL
			.elseif eax==IDCANCEL
				invoke	SendMessage,hWin,WM_CLOSE,NULL,NULL
			.endif
		.endif
	.elseif eax==WM_TIMER
		invoke GetLocalTime,ADDR LocalTime
	    movzx ecx, LocalTime.wHour
	    invoke	dwtoa, ecx, addr lpszHour
	    movzx ecx, LocalTime.wMinute
	    invoke	dwtoa, ecx, addr lpszMinute
	    movzx ecx, LocalTime.wSecond
	    invoke	dwtoa, ecx, addr lpszSecond
	    invoke	szMultiCat, 5, addr TimeStr2, addr lpszHour, offset szColon, \
	    		addr lpszMinute, offset szColon, addr lpszSecond
		INVOKE	SendDlgItemMessage,hWin,108,WM_SETTEXT, 0, addr TimeStr2	
	.elseif	eax==WM_CLOSE
		invoke KillTimer,hWin,400
		invoke	EndDialog,hWin,0
	.else
		mov	eax,FALSE
		ret
	.endif
	mov	eax,TRUE
	ret
DlgProc endp
getip proc
    invoke WSAStartup,101h,addr wdat
    invoke gethostbyname,addr lpbData
    mov eax, DWORD PTR [eax+12]
    mov eax, DWORD PTR [eax]          
    mov eax, DWORD PTR [eax]
    invoke inet_ntoa,eax
    mov DWORD PTR [lpbIP],eax
	invoke WSACleanup
    ret  
getip endp

FindComputerName proc
	LOCAL hKey:DWORD
	pusha
	invoke RegOpenKeyEx,HKEY_LOCAL_MACHINE,addr lpszComputerNameSubKey,0,KEY_QUERY_VALUE,addr hKey
    or eax,eax
    jnz ComputerNameKeyNotFound
    mov VBufLen,sizeof Buffer
    invoke RegQueryValueEx,hKey,addr lpszComputerNameValueName,0,addr lpdwType,addr lpbData,addr VBufLen
    cmp eax,ERROR_SUCCESS
    jne ComputerNameValNotFound
    Invoke RegCloseKey,hKey
    jmp ComputerNameEndKey
ComputerNameKeyNotFound:
    INVOKE MessageBox,NULL,addr szNoFindKey,addr szMBCapt,MB_OK
    jmp ComputerNameEndKey
ComputerNameValNotFound:
    INVOKE MessageBox,NULL,addr szNoFindVal,addr szMBCapt,MB_OK
    Invoke RegCloseKey,hKey
ComputerNameEndKey:
	popa
	ret
FindComputerName endp

GetScreenSaverState proc
	LOCAL hKey:DWORD
	pusha
	invoke RegOpenKeyEx,HKEY_USERS,addr lpszScreenSaverSubKey,0,KEY_QUERY_VALUE,addr hKey
    or eax,eax
    jnz ScreenSaverNameKeyNotFound
    mov SCRVBufLen,sizeof Buffer
    invoke RegQueryValueEx,hKey,addr lpszScreenSaverValueName,0,addr lpdwType,addr lpbSCRData,addr SCRVBufLen
    cmp eax,ERROR_SUCCESS
    jne ScreenSaverNameValNotFound
    Invoke RegCloseKey,hKey
    jmp ScreenSaverNameEndKey
ScreenSaverNameKeyNotFound:
    INVOKE MessageBox,NULL,addr szNoFindKey,addr szMBCapt,MB_OK
    jmp ScreenSaverNameEndKey
ScreenSaverNameValNotFound:
    INVOKE MessageBox,NULL,addr szNoFindVal,addr szMBCapt,MB_OK
    Invoke RegCloseKey,hKey
ScreenSaverNameEndKey:
	popa
	ret
GetScreenSaverState endp
end start